// 
//  coOccurenceMatrixFeature.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: coOccurenceMatrixFeature.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _COOCCURENCEMATRIXFEATURE_H_
#define _COOCCURENCEMATRIXFEATURE_H_

#include "textureFeature.h"
#include "image.h"
#include "shared_ptr.h"

class CoOccurenceMatrix;

class CoOccurenceMatrixFeature : public TextureFeature
{
    
public:
    
    enum Statistics {
        Energy,
        Entropy,
        Correlation,
        InverseDifferenceMoment,
        Inertia,
        ClusterShade,
        ClusterProminence,
        NB_STATISTICS
    };

    typedef shared_ptr< const CoOccurenceMatrix > CoOccMatrixPtr;

    static int getNbStatistics();

    CoOccurenceMatrixFeature(
        const Image< STUInt8 >* img,
        unsigned char           distances
    );

    CoOccurenceMatrixFeature( std::istream& is );

    // See ImageFeature
    Type getType() const;
    ColorSpaces::ColorSpace getColorSpace() const;

};

#endif /* _COOCCURENCEMATRIXFEATURE_H_ */
