// 
//  color.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: color.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _COLOR_H_
#define _COLOR_H_

#include "colorSpaces.h"
#include <ostream>

template< PixelDepth D > class Color;

template< PixelDepth D >
Color< D > operator-( const Color< D >&l, const Color< D >&r );

template< PixelDepth D >
class Color
{

    typedef typename depth_traits< D >::storage_type StorageType;

    template< PixelDepth D2 >
    friend Color< D2 > operator-( const Color< D2 >&l, const Color< D2 >&r );

public:

    Color( ColorSpaces::ColorSpace colorSpace, const StorageType* );
    Color( const Color< D >& c );
    ~Color();

    Color< D >& operator=( const Color< D >& c );

    void write( std::ostream& os ) const;

    ColorSpaces::ColorSpace getColorSpace() const;
    StorageType getValue( ColorSpaces::Channel channel ) const;

    float norm() const;

private:

    ColorSpaces::ColorSpace _colorSpace;
    StorageType*            _values;
};

#include "color.inline.h"

#endif /* _COLOR_H_ */
