// 
//  colorSpaces.inline.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: colorSpaces.inline.h 2926 2008-04-13 22:45:08Z benoit $
// 

#include <assert.h>

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int ColorSpaces::getNbChannels( ColorSpace colorSpace )
{
    assert( _initialized );
    return _colorSpaceInfo[colorSpace]._nbChannels;
}

///////////////////////////////////////////////////////////////////////////////

inline
int ColorSpaces::getChannelIndex( ColorSpace colorSpace, Channel channel )
{
    assert( _initialized );
    return ( channel - _colorSpaceInfo[colorSpace]._firstChannel );
}

///////////////////////////////////////////////////////////////////////////////

inline
bool ColorSpaces::isPerceptual( ColorSpace colorSpace )
{
    assert( _initialized );
    return _colorSpaceInfo[colorSpace]._isPerceptual;
}

///////////////////////////////////////////////////////////////////////////////

inline
bool ColorSpaces::isNative( ColorSpace colorSpace, Channel channel )
{
    assert( _initialized );
    return _isNative[colorSpace][channel];
}

///////////////////////////////////////////////////////////////////////////////

inline
const std::string& ColorSpaces::toString( ColorSpace colorSpace )
{
    assert( _initialized );
    return _colorSpaceInfo[colorSpace]._name;
}
