// 
//  colorUtil.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: colorUtil.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _COLORUTIL_H_
#define _COLORUTIL_H_

#include "colorSpaces.h"
#include "pixelDepths.h"

class ImageBase;
class ColorConverter;
class DirectColorConverter;

class ColorUtil : public ColorSpaces
{

    friend class ColorConverter;

public:

    static void initialize();
    static void finalize();

    static ImageBase* convert(
        const ImageBase* srcImg,
        ColorSpace       targetSpace,
        PixelDepth       targetDepth
    );

private:

    ColorUtil();

    static DirectColorConverter* getDirectConverter(
        ColorSpace srcSpace,
        PixelDepth srcDepth,
        ColorSpace targetSpace,
        PixelDepth targetDepth
    );

    static ColorConverter* _converters[NB_COLOR_SPACES][NB_PIXEL_DEPTHS]
                                      [NB_COLOR_SPACES][NB_PIXEL_DEPTHS];

    static bool _initialized;
};

#endif /* _COLORUTIL_H_ */
