// 
//  convertLabtoHVC.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertLabtoHVC.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "convertLabtoHVC.h"
#include <limits>
#include <math.h>

#ifndef M_PI
#define M_PI 3.141592653589793238462643383279502884197169399375
#endif

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertLabtoHVC< Di, Do >::ConvertLabtoHVC()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertLabtoHVC< Di, Do >::~ConvertLabtoHVC()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertLabtoHVC< Di, Do >::getSourceColorSpace() const
{
    return Lab;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertLabtoHVC< Di, Do >::getSourceDepth() const
{
    return Di;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertLabtoHVC< Di, Do >::getTargetColorSpace() const
{
    return HVC;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertLabtoHVC< Di, Do >::getTargetDepth() const
{
    return Do;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
void ConvertLabtoHVC< Di, Do >::convert(
    const PixelBuffer& srcBuffer,
    PixelBuffer&       outBuffer
) const
{
    const InputType* src =
    reinterpret_cast< const InputType* >( srcBuffer.getPixels() );
    OutputType* out =
        reinterpret_cast< OutputType* >( outBuffer.getPixels() );
    
    unsigned nbValues = srcBuffer.getHeight()
        * srcBuffer.getWidth();
    for( unsigned int i = 0; i < nbValues; ++i )
    {
        InputType L, a, b;
        L = *src++;
        a = *src++;
        b = *src++;
        
        *(out++) = atan2(b,a) + M_PI;
        *(out++) = L;
        *(out++) = sqrtf(a*a + b*b);
    }
}

///////////////////////////////////////////////////////////////////////////////

template class ConvertLabtoHVC< STFloat32, STFloat32 >;
