// 
//  convertLabtoHVC.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertLabtoHVC.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _CONVERTLABTOHVC_H_
#define _CONVERTLABTOHVC_H_

#include "colorConverter.h"

template< PixelDepth Di, PixelDepth Do >
class ConvertLabtoHVC : public DirectColorConverter
{
    
public:
    
    typedef typename depth_traits< Di >::storage_type InputType;
    typedef typename depth_traits< Do >::storage_type OutputType;
    
    ConvertLabtoHVC();
    ~ConvertLabtoHVC();

    ColorSpace getSourceColorSpace() const;
    PixelDepth getSourceDepth() const;
    ColorSpace getTargetColorSpace() const;
    PixelDepth getTargetDepth() const;

    void convert(
         const PixelBuffer& srcBuffer,
         PixelBuffer&       outBuffer
    ) const;
    
private:

    ConvertLabtoHVC( const ConvertLabtoHVC& );
};

#endif /* _CONVERTLABTOHVC_H_ */
