// 
//  convertRGBtoCMY.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertRGBtoCMY.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "convertRGBtoCMY.h"
#include <limits>

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoCMY< Di, Do >::ConvertRGBtoCMY()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoCMY< Di, Do >::~ConvertRGBtoCMY()
{}


///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertRGBtoCMY< Di, Do >::getSourceColorSpace() const
{
    return RGB;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoCMY< Di, Do >::getSourceDepth() const
{
    return Di;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertRGBtoCMY< Di, Do >::getTargetColorSpace() const
{
    return CMY;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoCMY< Di, Do >::getTargetDepth() const
{
    return Do;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
void ConvertRGBtoCMY< Di, Do >::convert(
    const PixelBuffer& srcBuffer,
    PixelBuffer&       outBuffer
) const
{
    const InputType* src =
        reinterpret_cast< const InputType* >( srcBuffer.getPixels() );
    OutputType* out =
        reinterpret_cast< OutputType* >( outBuffer.getPixels() );

    unsigned nbValues = srcBuffer.getHeight()
                        * srcBuffer.getWidth()
                        * srcBuffer.getNbChannels();
    for( unsigned int i = 0; i < nbValues; ++i )
    {
             *out = std::numeric_limits< OutputType >::max() - *src;
            ++out;
            ++src;
    }
}

///////////////////////////////////////////////////////////////////////////////

template class ConvertRGBtoCMY< STUInt8, STUInt8 >;
template class ConvertRGBtoCMY< STUInt16, STUInt16 >;
