// 
//  convertRGBtoCMY.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertRGBtoCMY.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _CONVERTRGBTOCMY_H_
#define _CONVERTRGBTOCMY_H_

#include "colorConverter.h"

template< PixelDepth Di, PixelDepth Do >
class ConvertRGBtoCMY : public DirectColorConverter
{

public:

    typedef typename depth_traits< Di >::storage_type InputType;
    typedef typename depth_traits< Do >::storage_type OutputType;

    ConvertRGBtoCMY();
    ~ConvertRGBtoCMY();

    ColorSpace getSourceColorSpace() const;
    PixelDepth getSourceDepth() const;
    ColorSpace getTargetColorSpace() const;
    PixelDepth getTargetDepth() const;

    void convert(
        const PixelBuffer& srcBuffer,
        PixelBuffer&       outBuffer
    ) const;

private:

    ConvertRGBtoCMY( const ConvertRGBtoCMY& );
};

#endif /* _CONVERTRGBTOCMY_H_ */
