// 
//  convertRGBtoGrayscale.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertRGBtoGrayscale.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "convertRGBtoGrayscale.h"
#include <limits>

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoGrayscale< Di, Do >::ConvertRGBtoGrayscale()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoGrayscale< Di, Do >::~ConvertRGBtoGrayscale()
{}


///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace
ConvertRGBtoGrayscale< Di, Do >::getSourceColorSpace() const
{
    return RGB;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoGrayscale< Di, Do >::getSourceDepth() const
{
    return Di;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace
ConvertRGBtoGrayscale< Di, Do >::getTargetColorSpace() const
{
    return Grayscale;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoGrayscale< Di, Do >::getTargetDepth() const
{
    return Do;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
void ConvertRGBtoGrayscale< Di, Do >::convert(
    const PixelBuffer& srcBuffer,
    PixelBuffer&       outBuffer
) const
{
    const InputType* src =
        reinterpret_cast< const InputType* >( srcBuffer.getPixels() );
    OutputType* out =
        reinterpret_cast< OutputType* >( outBuffer.getPixels() );

    unsigned nbPixels = srcBuffer.getHeight() * srcBuffer.getWidth();
    for( unsigned int i = 0; i < nbPixels; ++i )
    {
        InputType r, g, b;
        r = *(src++);
        g = *(src++);
        b = *(src++);

        *(out++) = static_cast< OutputType >( 0.299f*r + 0.587f*g + 0.114f*b );
    }
}

///////////////////////////////////////////////////////////////////////////////

template class ConvertRGBtoGrayscale< STUInt8, STUInt8 >;
template class ConvertRGBtoGrayscale< STUInt16, STUInt16 >;
template class ConvertRGBtoGrayscale< STFloat32, STFloat32 >;
