// 
//  convertRGBtoXYZ.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertRGBtoXYZ.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "convertRGBtoXYZ.h"
#include "pixelDepths.h"

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoXYZ< Di, Do >::ConvertRGBtoXYZ()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertRGBtoXYZ< Di, Do >::~ConvertRGBtoXYZ()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertRGBtoXYZ< Di, Do >::getSourceColorSpace() const
{
    return RGB;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoXYZ< Di, Do >::getSourceDepth() const
{
    return Di;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertRGBtoXYZ< Di, Do >::getTargetColorSpace() const
{
    return XYZ;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertRGBtoXYZ< Di, Do >::getTargetDepth() const
{
    return Do;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
void ConvertRGBtoXYZ< Di, Do >::convert(
    const PixelBuffer& srcBuffer,
    PixelBuffer&       outBuffer
) const
{
    const InputType* src =
        reinterpret_cast< const InputType* >( srcBuffer.getPixels() );
    OutputType* out =
        reinterpret_cast< OutputType* >( outBuffer.getPixels() );

    unsigned nbPixels = srcBuffer.getHeight() * srcBuffer.getWidth();
    const InputType maxVal = depth_traits< Di >::max();
    for( unsigned int i = 0; i < nbPixels; ++i )
    {
        InputType r, g, b;
        r = *(src++);
        g = *(src++);
        b = *(src++);

        *(out++) = (0.412453f*r + 0.357580f*g + 0.180423f*b) / maxVal;
        *(out++) = (0.212671f*r + 0.715160f*g + 0.072169f*b) / maxVal;
        *(out++) = (0.019334f*r + 0.119193f*g + 0.950227f*b) / maxVal;
    }
}

///////////////////////////////////////////////////////////////////////////////

template class ConvertRGBtoXYZ< STUInt8, STFloat32 >;
template class ConvertRGBtoXYZ< STUInt16, STFloat32 >;
template class ConvertRGBtoXYZ< STFloat32, STFloat32 >;
