// 
//  convertRGBtoXYZ.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertRGBtoXYZ.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _CONVERTRGBTOXYZ_H_
#define _CONVERTRGBTOXYZ_H_

#include "colorConverter.h"

template< PixelDepth Di, PixelDepth Do >
class ConvertRGBtoXYZ : public DirectColorConverter
{

public:

    typedef typename depth_traits< Di >::storage_type InputType;
    typedef typename depth_traits< Do >::storage_type OutputType;

    ConvertRGBtoXYZ();
    ~ConvertRGBtoXYZ();

    ColorSpace getSourceColorSpace() const;
    PixelDepth getSourceDepth() const;
    ColorSpace getTargetColorSpace() const;
    PixelDepth getTargetDepth() const;

    void convert(
        const PixelBuffer& srcBuffer,
        PixelBuffer&       outBuffer
    ) const;

private:

    ConvertRGBtoXYZ( const ConvertRGBtoXYZ& );
};

#endif /* _CONVERTRGBTOXYZ_H_ */
