// 
//  convertXYZtoLab.cpp
//  IFT630 - Processus concurrents et paralllisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertXYZtoLab.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "math.h"

#include "convertXYZtoLab.h"
#include <limits>

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertXYZtoLab< Di, Do >::ConvertXYZtoLab()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ConvertXYZtoLab< Di, Do >::~ConvertXYZtoLab()
{}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertXYZtoLab< Di, Do >::getSourceColorSpace() const
{
    return XYZ;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertXYZtoLab< Di, Do >::getSourceDepth() const
{
    return Di;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
ColorSpaces::ColorSpace ConvertXYZtoLab< Di, Do >::getTargetColorSpace() const
{
    return Lab;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
PixelDepth ConvertXYZtoLab< Di, Do >::getTargetDepth() const
{
    return Do;
}

///////////////////////////////////////////////////////////////////////////////

template< PixelDepth Di, PixelDepth Do >
void ConvertXYZtoLab< Di, Do >::convert(
    const PixelBuffer& srcBuffer,
    PixelBuffer&       outBuffer
) const
{
    const InputType* src =
        reinterpret_cast< const InputType* >( srcBuffer.getPixels() );
    OutputType* out =
        reinterpret_cast< OutputType* >( outBuffer.getPixels() );
    
    unsigned nbPixels = srcBuffer.getHeight() * srcBuffer.getWidth();
    for( unsigned int i = 0; i < nbPixels; ++i )
    {
        InputType x, y, z;
        x = *src++;
        y = *src++;
        z = *src++;

        // L*
        if (y > 0.001f)
            *(out++) = 116.0f * powf(y,1.0f/3.0f) - 16.0f;
        else
            *(out++) = 903.0f * y;

        // a*
        *(out++) = 500.0f * (powf(x,1.0f/3.0f) - powf(y,1.0f/3.0f));

        // b*
        *(out++) = 200.0f * (powf(x,1.0f/3.0f) - powf(z,1.0f/3.0f));
    }
}

///////////////////////////////////////////////////////////////////////////////

template class ConvertXYZtoLab< STFloat32, STFloat32 >;
