// 
//  convertXYZtoLab.h
//  IFT630 - Processus concurrents et paralllisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: convertXYZtoLab.h 2933 2008-04-14 03:51:07Z benoit $
// 

#ifndef _CONVERTXYZTOLAB_H_
#define _CONVERTXYZTOLAB_H_

#include "colorConverter.h"

template< PixelDepth Di, PixelDepth Do >
class ConvertXYZtoLab : public DirectColorConverter
{

public:

    typedef typename depth_traits< Di >::storage_type InputType;
    typedef typename depth_traits< Do >::storage_type OutputType;

    ConvertXYZtoLab();
    ~ConvertXYZtoLab();

    ColorSpace getSourceColorSpace() const;
    PixelDepth getSourceDepth() const;
    ColorSpace getTargetColorSpace() const;
    PixelDepth getTargetDepth() const;

    void convert(
        const PixelBuffer& srcBuffer,
        PixelBuffer&       outBuffer
    ) const;

private:

    ConvertXYZtoLab( const ConvertXYZtoLab& );
};

#endif /* _CONVERTXYZTOLAB_H_ */
