// 
//  correlogramFeature.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: correlogramFeature.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _CORRELOGRAMFEATURE_H_
#define _CORRELOGRAMFEATURE_H_

#include "textureFeature.h"
#include "shared_ptr.h"
#include <vector>

class Correlogram;
class IndexedImage;

class CorrelogramFeature : public TextureFeature
{
    
public:

    typedef shared_ptr< const Correlogram > CorrelogramPtr;

    static int getNbStatistics();

    CorrelogramFeature(
        const IndexedImage* img,
        unsigned char       distances
    );

    CorrelogramFeature( std::istream& is, ColorSpaces::ColorSpace colorSpace );

    // See ImageFeature
    Type getType() const;
    ColorSpaces::ColorSpace getColorSpace() const;

private:

    ColorSpaces::ColorSpace _colorSpace;
};

#endif /* _CORRELOGRAMFEATURE_H_ */
