// 
//  digestQueue.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: digestQueue.h 2940 2008-04-15 03:48:29Z benoit $
// 

#ifndef _DIGESTQUEUE_H_
#define _DIGESTQUEUE_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/thread.h>

#include "collectionReport.h"
#include "fsUtils.h"
#include "shared_ptr.h"
#include <vector>

class ImageReport;
class DigestThread;
class ImageReportFactory;

class DigestQueue {
    
public:
    
    DigestQueue(
        const FSUtils::FileList&                            fileList,
        const shared_ptr< const CollectionReport::Header >& header
    );
    
    void abort();
    
    bool getNextFile( std::wstring& file );
    
    size_t getSize() const;
    
    bool addReport( const shared_ptr< ImageReport >& imgReport );
    
    shared_ptr< CollectionReport > getCollectionReport();
    
private:

    void joinAll();
    
    FSUtils::FileList                            _fileList;
    std::vector< shared_ptr< DigestThread > >    _threads;
    shared_ptr< const CollectionReport::Header > _header;
    shared_ptr< CollectionReport >               _collection;
    
    mutable wxMutex   _fileListmutex;
    mutable wxMutex   _collectionMutex;
};

#endif /* _DIGESTQUEUE_H_ */
