// 
//  digestThread.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: digestThread.cpp 2940 2008-04-15 03:48:29Z benoit $
// 

#include "digestThread.h"
#include "imageReportFactory.h"
#include "collectionReport.h"
#include "stringUtils.h"

///////////////////////////////////////////////////////////////////////////////

DigestThread::DigestThread(
    const shared_ptr< const ImageReportFactory >& factory,
    DigestQueue*                                  queue
) : wxThread( wxTHREAD_JOINABLE ),
    _queue( queue ),
    _factory( factory ),
    _abort( false )
{}

///////////////////////////////////////////////////////////////////////////////

DigestThread::~DigestThread()
{}

///////////////////////////////////////////////////////////////////////////////

void* DigestThread::Entry()
{
    shared_ptr< CollectionReport > report( new CollectionReport() );
    
    std::wstring file;
    while( !_abort && _queue->getNextFile( file ) )
        _queue->addReport( _factory->create( file ) );
    
    return NULL;
}

///////////////////////////////////////////////////////////////////////////////

void DigestThread::OnExit()
{}

///////////////////////////////////////////////////////////////////////////////

void DigestThread::abort()
{
    _abort = true;
}
