// 
//  digestThread.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: digestThread.h 2940 2008-04-15 03:48:29Z benoit $
// 

#ifndef _DIGESTTHREAD_H_
#define _DIGESTTHREAD_H_

#include "digestQueue.h"
#include "shared_ptr.h"

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/thread.h>

class ImageReportFactory;

class DigestThread : public wxThread {

public:
    
    DigestThread(
        const shared_ptr< const ImageReportFactory >& factory,
        DigestQueue*                                  queue
    )
    ;
    ~DigestThread();
    
    void* Entry();
    
    void OnExit();
    
    void abort();

private:
    
    shared_ptr< const ImageReportFactory > _factory;
    DigestQueue*                           _queue;
    bool                                   _abort;
};

#endif /* _DIGESTTHREAD_H_ */
