// 
//  image.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: image.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "image.h"

///////////////////////////////////////////////////////////////////////////////

ImageBase::ImageBase(
    unsigned int width,
    unsigned int height,
    ColorSpace   colorSpace,
    unsigned int valueSize
) : _width( width ),
    _height( height ),
    _colorSpace( colorSpace ),
    _pixelBuffer( width, height,
                  ColorSpaces::getNbChannels( colorSpace ),
                  valueSize )
{}

///////////////////////////////////////////////////////////////////////////////

ImageBase::~ImageBase()
{}

///////////////////////////////////////////////////////////////////////////////

ImageBase* ImageBase::create(
    unsigned int width,
    unsigned int height,
    ColorSpace   colorSpace,
    PixelDepth   pixelDepth
)
{
    ImageBase* img = 0;
    switch( pixelDepth )
    {
        case STUInt8:
            img = new Image< STUInt8 >( width, height, colorSpace );
            break;
        case STUInt16:
            img = new Image< STUInt16 >( width, height, colorSpace );
            break;
        case STUInt32:
            img = new Image< STUInt32 >( width, height, colorSpace );
            break;
        case STFloat32:
            img = new Image< STFloat32 >( width, height, colorSpace );
            break;
        default:
            throw "Undefined type while creating image";
            break;
            
    }
    return img;
}
