// 
//  imageFeature.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: imageFeature.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _IMAGEFEATURE_H_
#define _IMAGEFEATURE_H_

#include "reportFileComponent.h"
#include "colorSpaces.h"
#include "int64.h"
#include <ostream>

class ImageFeature : public ReportFileComponent
{

public:

    enum Type { HISTOGRAM, CO_OCCURENCE, CORRELOGRAM };

    class Descriptor : public ReportFileComponent
    {
    
    public:
    
        Descriptor();
        Descriptor( std::istream& is );
    
        void write( std::ostream& os ) const;
    
        unsigned char _type;        //  1 byte
        unsigned char _colorSpace;  //  1 byte
        int64_t       _parameters;  //  8 bytes
        unsigned char _valueSize;   //  1 byte
        unsigned int  _nbValues;    //  4 bytes
        unsigned char _dummy;       //  1 byte
                                    // --
                                    // 16 bytes
    };

    virtual ~ImageFeature();

    virtual Type getType() const = 0;
    virtual ColorSpaces::ColorSpace getColorSpace() const = 0;

protected:

    ImageFeature();

};

#endif /* _IMAGEFEATURE_H_ */
