// 
//  imageFile.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: imageFile.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "imageFile.h"
#include "ppmImageFile.h"
#include "wxImageFile.h"
#include <algorithm>

///////////////////////////////////////////////////////////////////////////////

ImageFile* ImageFile::create( const std::wstring& filepath )
{
    // Get extension from filepath
    size_t pos = filepath.rfind( '.' );
    std::wstring ext( filepath.substr( pos + 1, filepath.size() ) );

    // Make sure the extension is lower case
    std::transform( ext.begin(), ext.end(), ext.begin(), tolower );

    // Return ImageFile based on extension
    if( ext == std::wstring( L"ppm" ) ) {
        return new PPMImageFile( filepath );
    }
    else {
        return new wxImageFile( filepath );
    }
}

///////////////////////////////////////////////////////////////////////////////

ImageFile::ImageFile( const std::wstring& filePath )
 : _filePath( filePath )
{}

///////////////////////////////////////////////////////////////////////////////

ImageFile::~ImageFile()
{}

///////////////////////////////////////////////////////////////////////////////

std::wstring ImageFile::getFilePath() const
{
    return _filePath;
}
