// 
//  imageFile.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: imageFile.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _IMAGEFILE_H_
#define _IMAGEFILE_H_

#include <string>
#include <istream>

class ImageBase;

class ImageFile
{

public:

    static ImageFile* create( const std::wstring& filepath );

    virtual ~ImageFile();

    std::wstring getFilePath() const;

    virtual ImageBase* read() const = 0;
    virtual void write( const ImageBase* image ) = 0;

protected:

    ImageFile( const std::wstring& filepath );

private:

    std::wstring _filePath;
};

#endif /* _IMAGEFILE_H_ */
