// 
//  imageRanker.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: imageRanker.h 2928 2008-04-13 22:48:01Z benoit $
// 

#ifndef _IMAGERANKER_H_
#define _IMAGERANKER_H_

#include "searchResult.h"
#include "shared_ptr.h"

class CollectionReport;
class ImageReport;

class ImageRanker
{

public:

    enum DistanceType{ Euclidean, Weighted, Intersection, Manhattan };

    virtual ~ImageRanker();

    // Used to extract a certain feature value or to calulate distances with
    // another ImageReport object stored as a data member in a child class.
    // The only restriction is that the value used for ranking is a float.
    // The default implementation returns 0.
    virtual float rank(
        const shared_ptr< const ImageReport >& report
    ) const;

protected:

    ImageRanker();
    ImageRanker( const ImageRanker& );
    ImageRanker& operator=( const ImageRanker& );
};

#endif /* _IMAGERANKER_H_ */
