// 
//  imageReportFactory.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: imageReportFactory.h 2928 2008-04-13 22:48:01Z benoit $
// 

#ifndef _IMAGEREPORTFACTORY_H_
#define _IMAGEREPORTFACTORY_H_

#include "collectionReport.h"
#include "shared_ptr.h"
#include <iostream>

class PixelIndexer;

class ImageReportFactory
{

public:

    ImageReportFactory( shared_ptr< const CollectionReport::Header > header );

    ImageReportFactory(
        shared_ptr< const CollectionReport::Header > header,
        std::istream&                                is
    );

    ~ImageReportFactory();

    shared_ptr< ImageReport > create( const std::wstring& filename ) const;
    shared_ptr< ImageReport > create( std::istream& is ) const;

    void writeHeader( std::ostream& os );

private:

    shared_ptr< const PixelIndexer > _rgbHistogramIndexer;
    shared_ptr< const PixelIndexer > _hvcHistogramIndexer;
    shared_ptr< const PixelIndexer > _correlogramIndexer;

    shared_ptr< const CollectionReport::Header > _header;

    int           _nbFeatures;
    unsigned char _corrDistances;
    unsigned char _coOccDistances;
};

#endif /* _IMAGEREPORTFACTORY_H_ */
