// 
//  indexedImage.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: indexedImage.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "indexedImage.h"
#include "pixelIndexer.h"

///////////////////////////////////////////////////////////////////////////////

IndexedImage::IndexedImage(
    const Image< STUInt8 >*            srcImg,
    shared_ptr< const PixelIndexer > indexer
) : ImageBase(
        srcImg->getWidth(),
        srcImg->getHeight(),
        Indexed,
        sizeof( StorageType ) ),
    _indexer( indexer )
{
    assert( srcImg->getColorSpace() == _indexer->getSourceColorSpace() );

    const Image< STUInt8 >::StorageType* src( srcImg->getPixels() );
    StorageType* out(
        reinterpret_cast< StorageType* >( ImageBase::getPixels() ) );

    unsigned long nbPixels( srcImg->getWidth() * srcImg->getHeight() );
    for( unsigned long i = 0; i < nbPixels; ++i ) {
        *( out++ ) = _indexer->getIndex( src );
        src += srcImg->getNbChannels();
    }
}

///////////////////////////////////////////////////////////////////////////////

IndexedImage::~IndexedImage()
{}
