// 
//  indexedImage.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: indexedImage.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _INDEXEDIMAGE_H_
#define _INDEXEDIMAGE_H_

#include "image.h"
#include "shared_ptr.h"

class PixelIndexer;

class IndexedImage : public ImageBase
{

public:

    typedef depth_traits< STUInt16 >::storage_type StorageType;

    IndexedImage(
        const Image< STUInt8 >*            srcImg,
        shared_ptr< const PixelIndexer > indexer
    );

    ~IndexedImage();

    const StorageType* getPixels( int x = 0, int y = 0) const;
    StorageType getValue( int x, int y ) const;

    shared_ptr< const PixelIndexer > getPixelIndexer() const;

    PixelDepth getPixelDepth() const;
    unsigned int getLineStride() const;

private:

    const shared_ptr< const PixelIndexer > _indexer;
};

#include "indexedImage.inline.h"

#endif /* _INDEXEDIMAGE_H_ */
