// 
//  indexedImage.inline.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: indexedImage.inline.h 2926 2008-04-13 22:45:08Z benoit $
// 

///////////////////////////////////////////////////////////////////////////////

inline
shared_ptr< const PixelIndexer > IndexedImage::getPixelIndexer() const
{
    return _indexer;
}

///////////////////////////////////////////////////////////////////////////////

inline
const IndexedImage::StorageType* IndexedImage::getPixels(
    int x /* = 0 */,
    int y /* = 0 */
) const
{
    return reinterpret_cast< const StorageType* >(
        ImageBase::getPixels( x, y ) );
}

///////////////////////////////////////////////////////////////////////////////

inline
IndexedImage::StorageType IndexedImage::getValue( int x, int y ) const
{
    return *( getPixels( x, y ) );
}

///////////////////////////////////////////////////////////////////////////////

inline
PixelDepth IndexedImage::getPixelDepth() const
{
    return STUInt16;
}

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int IndexedImage::getLineStride() const
{
    return ImageBase::getLineStride() / sizeof( StorageType );
}
