// 
//  osUtils.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: osUtils.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _OSUTILS_H_
#define _OSUTILS_H_

class OSUtils
{

public:

    enum Endianness { LittleEndian = 0, BigEndian, Unknown };

    static void initialize();
    static void finalize();

    static bool isBigEndian();
    static bool isLittleEndian();
    static Endianness getEndianness();

    static bool hasAltivec();

    static int getCPUcount();

private:

    OSUtils();
    OSUtils( const OSUtils& );

    static Endianness _endianness;
    static bool       _hasAltivec;
    static bool       _initialized;
};


#endif /* _OSUTILS_H_ */
