// 
//  pixelBuffer.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: pixelBuffer.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "pixelBuffer.h"
#include <memory.h>

///////////////////////////////////////////////////////////////////////////////

PixelBuffer::PixelBuffer(
    unsigned int width,
    unsigned int height,
    unsigned int nbChannels,
    unsigned int valueSize
) : _width( width ),
    _height( height),
    _nbChannels( nbChannels ),
    _valueSize( valueSize )
{
    _pixelSize = _nbChannels * _valueSize;
    _lineStride = _width * _pixelSize;

    // Allocate memory
    _data = new unsigned char[ _height * _lineStride ];

    // Fill with zeros
    memset( _data, 0, _height * _lineStride );
}

///////////////////////////////////////////////////////////////////////////////

PixelBuffer::~PixelBuffer()
{
    // Free memory
    delete[] _data;
}
