// 
//  pixelBuffer.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: pixelBuffer.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _PIXELBUFFER_H_
#define _PIXELBUFFER_H_

class PixelBuffer
{

public:

    PixelBuffer(
        unsigned int width,
        unsigned int height,
        unsigned int nbChannels,
        unsigned int valueSize
    );
    ~PixelBuffer();

    unsigned int getWidth() const;
    unsigned int getHeight() const;
    unsigned int getLineStride() const;
    unsigned int getNbChannels() const;

    unsigned char* getPixels( int x = 0, int y = 0);
    const unsigned char* getPixels( int x = 0, int y = 0) const;

private:

    PixelBuffer( const PixelBuffer& );
    PixelBuffer& operator=( const PixelBuffer& );

    unsigned int   _width;
    unsigned int   _height;
    unsigned int   _nbChannels;
    unsigned int   _valueSize;
    unsigned int   _pixelSize;
    unsigned int   _lineStride;
    unsigned char* _data;
};

#include "pixelBuffer.inline.h"

#endif /* _PIXELBUFFER_H_ */
