// 
//  pixelBuffer.inline.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: pixelBuffer.inline.h 2926 2008-04-13 22:45:08Z benoit $
// 

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int PixelBuffer::getWidth() const
{
    return _width;
}

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int PixelBuffer::getHeight() const
{
    return _height;
}

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int PixelBuffer::getNbChannels() const
{
    return _nbChannels;
}

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int PixelBuffer::getLineStride() const
{
    return _lineStride;
}

///////////////////////////////////////////////////////////////////////////////

inline
unsigned char* PixelBuffer::getPixels(
    int x /* = 0 */,
    int y /* = 0 */
)
{
    return _data + ( ( _lineStride * y ) + ( x * _pixelSize ) );
}

///////////////////////////////////////////////////////////////////////////////

inline
const unsigned char* PixelBuffer::getPixels(
    int x /* = 0 */,
    int y /* = 0 */
) const
{
    return _data + ( ( _lineStride * y ) + ( x * _pixelSize ) );
}
