// 
//  pixelDepths.h
//  IFT630 - Processus concurrents et paralllisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: pixelDepths.h 2933 2008-04-14 03:51:07Z benoit $
// 

#ifndef _PIXELDEPTHS_H_
#define _PIXELDEPTHS_H_

#include <limits>

enum PixelDepth { STUInt8, STUInt16, STUInt32, STFloat32, NB_PIXEL_DEPTHS };

template< PixelDepth D >
struct depth_traits
{};

template <>
struct depth_traits< STUInt8 >
{
    typedef unsigned char storage_type;
    static storage_type max() {
        return std::numeric_limits< storage_type >::max();
    }
};

template <>
struct depth_traits< STUInt16 >
{
    typedef unsigned short int storage_type;
    static storage_type max() {
        return std::numeric_limits< storage_type >::max();
    }
};

template <>
struct depth_traits< STUInt32 >
{
    typedef unsigned int storage_type;
    static storage_type max() {
        return std::numeric_limits< storage_type >::max();
    }
};

template <>
struct depth_traits< STFloat32 >
{
    typedef float storage_type;
    static storage_type max() {
        return 1.0f;
    }
};

#endif /* _PIXELDEPTHS_H_ */
