// 
//  searchResult.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: searchResult.h 2928 2008-04-13 22:48:01Z benoit $
// 

#ifndef _SEARCHRESULT_H_
#define _SEARCHRESULT_H_

#include "imageReport.h"
#include "shared_ptr.h"

class ImageReport;

class SearchResult
{

public:

    typedef shared_ptr< const ImageReport > ReportPtr;

    SearchResult()
    : _report(), _score( 0.0f )
    {}

    SearchResult( const ReportPtr& report, float score )
    : _report( report ), _score( score )
    {}

    const std::wstring& getFilename() const
    { return _report->getFilename(); }

    ReportPtr getImageReport() const
    { return _report; }

    float getScore() const
    { return _score; }

    bool operator<( const SearchResult& right ) const
    { return _score < right._score; }

private:

    ReportPtr _report;
    float     _score;
};

#endif /* _SEARCHRESULT_H_ */
