// 
//  staticPixelIndexer.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: staticPixelIndexer.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _STATICPIXELINDEXER_H_
#define _STATICPIXELINDEXER_H_

#include "pixelIndexer.h"
#include "colorSpaces.h"
#include "pixelDepths.h"
#include "int64.h"

class StaticPixelIndexer : public PixelIndexer
{

public:

    static StaticPixelIndexer* fromParams( int64_t params );

    StaticPixelIndexer(
        unsigned short splitR,
        unsigned short splitG,
        unsigned short splitB
    );

    // See PixelIndexer
    ColorSpaces::ColorSpace getSourceColorSpace() const;
    ColorSpaces::ColorSpace getTargetColorSpace() const;
    unsigned int getIndex( const PixelStorageType* pixel ) const;

    const Color< STFloat32>& getBinCenter(
        PixelIndexer::BinIndexStorageType bin
    ) const;
    
private:

    const unsigned short _splitR;
    const unsigned short _splitG;
    const unsigned short _splitB;

    std::vector< Color< STFloat32> > _binCenters;

};

#include "staticPixelIndexer.inline.h"

#endif /* _STATICPIXELINDEXER_H_ */
