// 
//  staticPixelIndexer.inline.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: staticPixelIndexer.inline.h 2926 2008-04-13 22:45:08Z benoit $
// 

#include "color.h"
#include <math.h>

///////////////////////////////////////////////////////////////////////////////

inline
unsigned int StaticPixelIndexer::getIndex(
    const PixelStorageType* pixel
) const
{
    PixelStorageType r, g, b;
    r = *(pixel++);
    g = *(pixel++);
    b = *(pixel);

    unsigned int i, j, k, index;

    i = r * _splitR / 256;
    j = g * _splitG / 256;
    k = b * _splitB / 256;

    index = k * _splitR * _splitG + // plane offset (B)
            j * _splitR           + // line offset  (G)
            i;                      // cell offset  (R)

    return index;
}

///////////////////////////////////////////////////////////////////////////////

inline
ColorSpaces::ColorSpace StaticPixelIndexer::getSourceColorSpace() const
{
    return ColorSpaces::RGB;
}

///////////////////////////////////////////////////////////////////////////////

inline
ColorSpaces::ColorSpace StaticPixelIndexer::getTargetColorSpace() const
{
    return ColorSpaces::RGB;
}

///////////////////////////////////////////////////////////////////////////////

inline
const Color< STFloat32 >& StaticPixelIndexer::getBinCenter(
    unsigned int bin
) const
{
    assert( bin < getNbBins() );
    return _binCenters[ bin ];
}
