// 
//  stringUtils.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: stringUtils.cpp 2928 2008-04-13 22:48:01Z benoit $
// 

#include "stringUtils.h"
#include <algorithm>

char wide_to_narrow( wchar_t w ) { return char( w ); }
char narrow_to_wide( char n ) { return wchar_t( n ); }

////////////////////////////////////////////////////////////////////////

std::string wstr2str( const std::wstring& ws )
{
    std::string str( " ", ws.length() );
    std::transform( ws.begin(), ws.end(), str.begin(), wide_to_narrow );
    return str;
}

////////////////////////////////////////////////////////////////////////

std::wstring str2wstr( const std::string& ns )
{
    std::wstring str;
    std::transform( ns.begin(), ns.end(), std::back_inserter( str ),
        narrow_to_wide );
    return str;
}
