// 
//  textureFeature.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: textureFeature.h 2928 2008-04-13 22:48:01Z benoit $
// 

#ifndef _TEXTUREFEATURE_H_
#define _TEXTUREFEATURE_H_

#include "imageFeature.h"

class TextureFeature : public ImageFeature
{

public:

    typedef std::pair< float, float > MinMaxPair;
    typedef std::vector< MinMaxPair > MinMaxVector;

    // See ReportFileComponent
    void write( std::ostream& os ) const;

    virtual ~TextureFeature();

    // Normalize statistic vector
    void normalize( const MinMaxVector& minMaxValues );

    // Various texture statistics distances
    float euclideanDistance( const TextureFeature& left ) const;
    float manhattanDistance( const TextureFeature& left ) const;
    
    float getStatValue( unsigned int i ) const;

protected:

    TextureFeature();

    TextureFeature( std::istream& is, size_t nbStats );
    
    void addStatistic( float stat );

private:

    std::vector< float > _statistics;
};

#endif /* _TEXTUREFEATURE_H_ */
