// 
//  textureFeatureNormalizer.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: textureFeatureNormalizer.cpp 2928 2008-04-13 22:48:01Z benoit $
// 

#include "textureFeatureNormalizer.h"
#include "imageReport.h"

///////////////////////////////////////////////////////////////////////////////

TextureFeatureNormalizer::TextureFeatureNormalizer(
    ImageFeature::Type                  type,
    const TextureFeature::MinMaxVector& minMaxPairs
) : _type( type ),
    _minMaxPairs( minMaxPairs )
{}

///////////////////////////////////////////////////////////////////////////////

void TextureFeatureNormalizer::process( ImageReport& report )
{
    const shared_ptr< TextureFeature > texture(
        dynamic_pointer_cast< TextureFeature >( report.getFeature( _type ) ) );

    texture->normalize( _minMaxPairs );
}
