// 
//  uiColorTab.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiColorTab.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _UICOLORTAB_H_
#define _UICOLORTAB_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "uiSplitRGB.h"
#include "uiSplitHVC.h"

class UiColorTab : public wxPanel
{

public:

    struct Values {
        bool               _generateRGB;
        bool               _generateHVC;
        UiSplitRGB::Values _rgbValues;
        UiSplitHVC::Values _hvcValues;
    };

    UiColorTab( wxWindow* parent );

    void OnEnableRGB( wxCommandEvent& event );
    void OnEnableHVC( wxCommandEvent& event );

    Values getValues() const;

private:

    wxCheckBox* _rgbCheckBox;
    wxCheckBox* _hvcCheckBox;

    UiSplitRGB* _uiSplitRGB;
    UiSplitHVC* _uiSplitHVC;

    DECLARE_EVENT_TABLE()

};

#endif /* _UICOLORTAB_H_ */
