// 
//  uiDigestFrame.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiDigestFrame.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _UIDIGESTFRAME_H_
#define _UIDIGESTFRAME_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "uiColorTab.h"
#include "uiTextureTab.h"
#include "collectionReport.h"
#include <wx/bookctrl.h>

class UiDigestFrame : public wxFrame
{

public:

    struct Values {
        UiColorTab::Values   _colorValues;
        UiTextureTab::Values _textureValues;
    };

    UiDigestFrame();

    wxString getInputDirPath() const;

    void OnBrowse( wxCommandEvent &event );
    void OnSave( wxCommandEvent &event );

    Values getValues() const;

private:

    shared_ptr< CollectionReport::Header > generateHeader() const;

    wxString _dirPath;

    UiColorTab*   _uiColorTab;
    UiTextureTab* _uiTextureTab;

    wxBookCtrl*   _book;
    wxStaticText* _dirPathTXT;
    wxButton*     _saveButton;

    DECLARE_EVENT_TABLE()

};

#endif /* _UIDIGESTFRAME_H_ */
