#ifndef _UIDIGESTPROGRESS_H_
#define _UIDIGESTPROGRESS_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "collectionReport.h"
#include "fsUtils.h"
#include "shared_ptr.h"
#include <wx/timer.h>

class DigestQueue;
class ImageReportFactory;

class UiDigestProgress : public wxFrame {

public:
    
    UiDigestProgress(
        const FSUtils::FileList&                            fileList,
        const shared_ptr< const CollectionReport::Header >& header
    );

    void OnCancel( wxCommandEvent &event );
    void OnTimer( wxTimerEvent &event );
    void OnComplete();
    
private:
    
    wxTimer                   _timer;
    wxGauge*                  _gauge;
    wxStaticText*             _statusTxt;
    wxButton*                 _cancelBtn;
    
    shared_ptr< DigestQueue >                    _queue;
    shared_ptr< const CollectionReport::Header > _header;
    
    DECLARE_EVENT_TABLE()
};

#endif /* _UIDIGESTPROGRESS_H_ */
