// 
//  uiDistancesSelector.cpp
//  IFT630 - Processus concurrents et paralllisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiDistancesSelector.cpp 2933 2008-04-14 03:51:07Z benoit $
// 

#include "uiDistancesSelector.h"

///////////////////////////////////////////////////////////////////////////////

UiDistancesSelector::UiDistancesSelector( wxWindow* parent )
 : wxPanel( parent ),
   _staticBox( new wxStaticBox(
                    this,
                    wxID_STATIC,
                    _T( "Pixel distances") ) )
{
    wxStaticBoxSizer* sizer = new wxStaticBoxSizer( _staticBox, wxHORIZONTAL );
    for(int i = 0; i < 4; ++i) {
        wxString label;
        label << (i+1) << _T( " px" );
        _distCheckBox[i] = new wxCheckBox( this, wxID_ANY, label  );
        sizer->Add( _distCheckBox[i], 0, wxLEFT, 10 );
    }
    _distCheckBox[0]->SetValue( true );
    SetSizer( sizer );
}

///////////////////////////////////////////////////////////////////////////////

bool UiDistancesSelector::Enable( bool enable )
{
    bool returnVal = false;
    returnVal |= _staticBox->Enable( enable );
    for(int i = 0; i < 4; ++i ) {
        returnVal |= _distCheckBox[i]->Enable( enable );
    }
    return returnVal;
}
///////////////////////////////////////////////////////////////////////////////

bool UiDistancesSelector::Disable()
{
    return Enable( false );
}

///////////////////////////////////////////////////////////////////////////////

UiDistancesSelector::Values UiDistancesSelector::getValues() const
{
    Values dists;
    for(int i = 0; i < 4; ++i ) {
        if( _distCheckBox[i]->GetValue() ) {
            dists.push_back( i + 1 );
        }
    }
    return dists;
}

///////////////////////////////////////////////////////////////////////////////

int64_t UiDistancesSelector::toParams() const
{
    assert( sizeof( int64_t ) == 8 );

    int64_t intParams = 0;
    unsigned char* params( reinterpret_cast< unsigned char* >( &intParams ) );

    // We flip bits for enabled distances
    // note: we could support distances up to 8 px
    Values dists( getValues() );
    for( Values::const_iterator it( dists.begin() ); it != dists.end(); ++it ) {
        params[7] |= ( 1 << (*it - 1) );
    }

    return intParams;
}
