// 
//  uiGridItem.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiGridItem.h 2928 2008-04-13 22:48:01Z benoit $
// 

#ifndef _UIGRIDITEM_H_
#define _UIGRIDITEM_H_

#include <wx/wx.h>

#include "wxThumbnailItem.h"
#include "wxThumbnailCtrl.h"
#include "searchResult.h"

class SearchResult;

class UiGridItem : public wxThumbnailItem
{

    DECLARE_CLASS( UiGridItem )

public:
        
    UiGridItem( const SearchResult& result, float scale = 1.0f );
    UiGridItem( const UiGridItem& item);
    UiGridItem();

    virtual ~UiGridItem();

    void operator=(const UiGridItem&);

    wxSize DoGetBestSize() const;

    virtual bool Draw(
        wxDC& dc,
        wxThumbnailCtrl* ctrl,
        const wxRect& rect,
        int style
    );

    virtual bool Load( wxThumbnailCtrl* ctrl, bool forceLoad );

    void Init();

    bool Create(const SearchResult& result, float _scale);

    // Shorthand
    inline SearchResult::ReportPtr getImageReport() const
    { return _result.getImageReport(); }

    inline wxString getName() const
    { return wxString( _result.getFilename().c_str() ); }

    inline float getScore() const
    { return _result.getScore(); }

    void setScale(float value);
    inline float getScale()
    { return _scale; }

    const wxBitmap& getThumbnail() const
    { return *_thumbnail; }

    const wxImage& getImage() const
    { return *_image; }
    
private:

    SearchResult _result;

    wxImage*   _image;
    wxBitmap*  _thumbnail;
    float      _scale;
        
};

#endif /* _UIGRIDITEM_H_ */
