// 
//  uiSearchApplication.cpp
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiSearchApplication.cpp 2926 2008-04-13 22:45:08Z benoit $
// 

#include "uiSearchApplication.h"
#include "uiSearchFrame.h"
#include "colorSpaces.h"
#include "colorUtil.h"
#include "osUtils.h"

///////////////////////////////////////////////////////////////////////////////

// Let wxWidgets generate the main()
IMPLEMENT_APP( UiSearchApplication )

///////////////////////////////////////////////////////////////////////////////

bool UiSearchApplication::OnInit()
{
    OSUtils::initialize();
    ColorSpaces::initialize();
    ColorUtil::initialize();

    ::wxInitAllImageHandlers();

    // Create the digest frame window
    UiSearchFrame *frame = new UiSearchFrame( 0 );
    frame->Show( true );

    return true;
}

///////////////////////////////////////////////////////////////////////////////

int UiSearchApplication::OnExit()
{
    ColorUtil::finalize();
    ColorSpaces::finalize();
    OSUtils::finalize();

    return 0;
}
