// 
//  uiSearchOptions.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiSearchOptions.h 2940 2008-04-15 03:48:29Z benoit $
// 

#ifndef _UISEARCHOPTIONS_H_
#define _UISEARCHOPTIONS_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "collectionReport.h"

class UiSearchOptions : public wxPanel
{

public:

    UiSearchOptions( wxWindow* parent );

    void OnFeatureChange( wxCommandEvent& event );
    void OnDistanceChange( wxCommandEvent& event );

    void SetCollectionHeader(
        const shared_ptr< const CollectionReport::Header >& header );
    
    bool Enable( bool enable = true );
    bool Disable();

    shared_ptr< ImageRanker > generateImageRanker(
        shared_ptr< const ImageReport > query
    );

private:

    enum Mode { NONE, COLOR, TEXTURE };

    void detectOptions();

    wxStaticBox*   _featureStaticBox;
    wxStaticBox*   _distanceStaticBox;

    wxRadioButton* _featureRadioButtons[4];
    wxRadioButton* _distanceRadioButtons[4];

    bool _hasHistogramRGB;
    bool _hasHistogramHVC;
    bool _hasCoOccurence;
    bool _hasCorrelogram;

    ImageRanker::DistanceType _currentDistance;
    ImageFeature::Type        _currentType;
    ColorSpaces::ColorSpace   _currentColorSpace;
    Mode                      _mode;

    shared_ptr< const CollectionReport::Header > _header;

    DECLARE_EVENT_TABLE()
};

#endif /* _UISEARCHOPTIONS_H_ */
