// 
//  uiSplitHVC.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiSplitHVC.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _UISPLITHVC_H_
#define _UISPLITHVC_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/spinctrl.h>
#include "int64.h"

class UiSplitHVC : public wxPanel
{

public:

    struct Values
    {
        int64_t toParams() const;

        int _rSplit;
        int _gSplit;
        int _bSplit;
        int _nbBins;
    };

    UiSplitHVC( wxWindow* parent );

    void OnSplitChange( wxSpinEvent &event );

    Values getValues() const;

    bool Enable( bool enable = true );
    bool Disable();

private:

    wxStaticBox*  _hvcStaticBox;

    wxSpinCtrl*   _splitR;
    wxSpinCtrl*   _splitG;
    wxSpinCtrl*   _splitB;
    wxSpinCtrl*   _splitHVC;

    wxStaticText* _splitRtxt;
    wxStaticText* _splitGtxt;
    wxStaticText* _splitBtxt;
    wxStaticText* _splitHVCtxt;

    DECLARE_EVENT_TABLE()

};

#endif /* _UISPLITHVC_H_ */
