// 
//  uiSplitRGB.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiSplitRGB.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _UISPLITRGB_H_
#define _UISPLITRGB_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/spinctrl.h>
#include "int64.h"

class UiSplitRGB : public wxPanel
{

public:

    struct Values
    {
        int64_t toParams() const;
        unsigned int nbBins() const;

        int _rSplit;
        int _gSplit;
        int _bSplit;
    };

    UiSplitRGB( wxWindow* parent );

    void OnSplitChange( wxSpinEvent &event );

    Values getValues() const;

    bool Enable( bool enable = true );
    bool Disable();

private:

    wxStaticBox*  _rgbStaticBox;

    wxSpinCtrl*   _splitR;
    wxSpinCtrl*   _splitG;
    wxSpinCtrl*   _splitB;

    wxStaticText* _splitRtxt;
    wxStaticText* _splitGtxt;
    wxStaticText* _splitBtxt;

    wxStaticText* _nbBinsTxt;

    DECLARE_EVENT_TABLE()

};


#endif /* _UISPLITRGB_H_ */
