// 
//  uiTextureTab.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: uiTextureTab.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _UITEXTURETAB_H_
#define _UITEXTURETAB_H_

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "uiSplitRGB.h"
#include "uiSplitHVC.h"
#include "uiDistancesSelector.h"
#include "int64.h"

class UiTextureTab : public wxPanel
{

public:

    struct Values {
        bool               _generateCoOcc;
        bool               _generateCorr;
        bool               _useRGB;
        bool               _useHVC;
        int64_t            _distCoOcc;
        int64_t            _distCorr;
        UiSplitRGB::Values _rgbValues;
        UiSplitHVC::Values _hvcValues;
    };

    UiTextureTab( wxWindow* parent );

    void OnGenerateCoOcc( wxCommandEvent& event );
    void OnGenerateCorr( wxCommandEvent& event );
    void OnUseRGB( wxCommandEvent& event );
    void OnUseHVC( wxCommandEvent& event );

    Values getValues() const;

private:

    wxCheckBox*          _generateCoOccurence;
    wxCheckBox*          _generateCorrelogram;
    wxRadioButton*       _useRGB;
    wxRadioButton*       _useHVC;
    UiSplitRGB*          _uiSplitRGB;
    UiSplitHVC*          _uiSplitHVC;
    UiDistancesSelector* _coOccDistances;
    UiDistancesSelector* _corrDistances;

    DECLARE_EVENT_TABLE()

};

#endif /* _UITEXTURETAB_H_ */
