// 
//  wxThumbnailEvent.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: wxThumbnailEvent.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _WXTHUMBNAILEVENT_H_
#define _WXTHUMBNAILEVENT_H_

#include <wx/event.h>

// Event class for wxThumbnailCtrl notifications
class wxThumbnailEvent : public wxNotifyEvent
{
public:
    wxThumbnailEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
        : wxNotifyEvent(commandType, winid),
        _itemIndex(-1), _flags(0)
        { }

    wxThumbnailEvent(const wxThumbnailEvent& event)
        : wxNotifyEvent(event),
        _itemIndex(event._itemIndex), _flags(event._flags)
        { }

    int GetIndex() const
    { return _itemIndex; }

    void SetIndex( int n )
    { _itemIndex = n; }

    int GetFlags() const
    { return _flags; }

    void SetFlags(int flags)
    { _flags = flags; }

    virtual wxEvent *Clone() const
    { return new wxThumbnailEvent( *this ); }

protected:

    int _itemIndex;
    int _flags;

private:

    DECLARE_DYNAMIC_CLASS_NO_ASSIGN( wxThumbnailEvent )
};

#endif /* _WXTHUMBNAILEVENT_H_ */
