// 
//  wxThumbnailItem.h
//  IFT630 - Processus concurrents et parallélisme
//  Benoit Gagnon (05 634 691)
//  
//  $Id: wxThumbnailItem.h 2926 2008-04-13 22:45:08Z benoit $
// 

#ifndef _WXTHUMBNAILITEM_H_
#define _WXTHUMBNAILITEM_H_

#include <wx/object.h>

class wxThumbnailCtrl;
class wxRect;

// Drawing styles/states
const int wxTHUMBNAIL_SELECTED( 0x01 );
const int wxTHUMBNAIL_TAGGED(   0x02 );
const int wxTHUMBNAIL_FOCUSSED( 0x04 );
const int wxTHUMBNAIL_IS_FOCUS( 0x08 );

///////////////////////////////////////////////////////////////////////////////

class wxDC;

class wxThumbnailItem: public wxObject
{
    DECLARE_CLASS( wxThumbnailItem )

public:

    wxThumbnailItem( const wxString& filename = wxEmptyString )
    { _filename = filename; }

    /// Filename
    void SetFilename( const wxString& filename )
    { _filename = filename; }

    const wxString& GetFilename() const
    { return _filename; }

    /// Draw the item
    virtual bool Draw(
        wxDC&            dc,
        wxThumbnailCtrl* ctrl,
        const wxRect&    rect,
        int              style
    );

    /// Draw the background
    virtual bool DrawBackground(
        wxDC&            dc,
        wxThumbnailCtrl* ctrl,
        const wxRect&    rect,
        const wxRect&    imageRect,
        int              style,
        int              index
    );

    /// Load the thumbnail
    virtual bool Load(
        wxThumbnailCtrl* WXUNUSED( ctrl ),
        bool WXUNUSED(forceLoad)
    )
    { return false; }

protected:

    wxString    _filename;

};

#endif /* _WXTHUMBNAILITEM_H_ */
